﻿using Infragistics.Win.UltraWinGrid;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace GroupHeaderArrangement
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            DataTable dt = new DataTable();
            dt.Columns.Add("Name", typeof(string));
            for (int i = 0; i < 31; i++)
                dt.Columns.Add(String.Format("Dec {0}", i+1), typeof(string));

            dt.Rows.Add("Administration", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "");
            dt.Rows.Add("Benson George", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "");
            dt.Rows.Add("Chanson d'Amour", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "");
            dt.Rows.Add("Flip Jerry", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "");
            dt.Rows.Add("Flop Jenny", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "");
            dt.Rows.Add("Fly Elfi", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "");

            ultraGrid1.DataSource = dt;
            UltraGridBand band = ultraGrid1.DisplayLayout.Bands[0];
            band.RowLayoutStyle = RowLayoutStyle.GroupLayout;
            band.ColHeadersVisible = false;

            UltraGridGroup groupOrg = band.Groups.Add("GroupOrg");
            groupOrg.Header.Caption = "";
            band.Columns["Name"].RowLayoutColumnInfo.ParentGroup = groupOrg;

            UltraGridGroup groupDecember = band.Groups.Add("December");
            UltraGridGroup groupWeek49 = band.Groups.Add("49");
            UltraGridGroup groupWeek50 = band.Groups.Add("50");
            UltraGridGroup groupWeek51 = band.Groups.Add("51");
            UltraGridGroup groupWeek52 = band.Groups.Add("52");
            UltraGridGroup groupWeek53 = band.Groups.Add("53");

            groupWeek49.RowLayoutGroupInfo.ParentGroup = groupDecember;
            groupWeek50.RowLayoutGroupInfo.ParentGroup = groupDecember;
            groupWeek51.RowLayoutGroupInfo.ParentGroup = groupDecember;
            groupWeek52.RowLayoutGroupInfo.ParentGroup = groupDecember;
            groupWeek53.RowLayoutGroupInfo.ParentGroup = groupDecember;

            UltraGridGroup groupDay1 = band.Groups.Add("1");
            UltraGridGroup groupDay8 = band.Groups.Add("8");
            UltraGridGroup groupDay15 = band.Groups.Add("15");
            UltraGridGroup groupDay22 = band.Groups.Add("22");
            UltraGridGroup groupDay29 = band.Groups.Add("29");

            groupDay1.RowLayoutGroupInfo.ParentGroup = groupDecember;
            groupDay1.RowLayoutGroupInfo.OriginX = 1;
            groupDay1.RowLayoutGroupInfo.SpanX = 11;
            groupDay8.RowLayoutGroupInfo.ParentGroup = groupDecember;
            groupDay8.RowLayoutGroupInfo.OriginX = 13;
            groupDay8.RowLayoutGroupInfo.SpanX = 13;
            groupDay15.RowLayoutGroupInfo.ParentGroup = groupDecember;
            groupDay15.RowLayoutGroupInfo.OriginX = 27;
            groupDay15.RowLayoutGroupInfo.SpanX = 13;
            groupDay22.RowLayoutGroupInfo.ParentGroup = groupDecember;
            groupDay22.RowLayoutGroupInfo.OriginX = 41;
            groupDay22.RowLayoutGroupInfo.SpanX = 13;
            groupDay29.RowLayoutGroupInfo.ParentGroup = groupDecember;
            groupDay29.RowLayoutGroupInfo.OriginX = 55;
            groupDay29.RowLayoutGroupInfo.SpanX = 7;

            band.Columns["Dec 1"].RowLayoutColumnInfo.ParentGroup = groupWeek49;
            band.Columns["Dec 2"].RowLayoutColumnInfo.ParentGroup = groupWeek49;
            band.Columns["Dec 3"].RowLayoutColumnInfo.ParentGroup = groupWeek49;
            band.Columns["Dec 4"].RowLayoutColumnInfo.ParentGroup = groupWeek49;
            band.Columns["Dec 5"].RowLayoutColumnInfo.ParentGroup = groupWeek49;
            band.Columns["Dec 6"].RowLayoutColumnInfo.ParentGroup = groupWeek49;
            band.Columns["Dec 7"].RowLayoutColumnInfo.ParentGroup = groupWeek50;
            band.Columns["Dec 8"].RowLayoutColumnInfo.ParentGroup = groupWeek50;
            band.Columns["Dec 9"].RowLayoutColumnInfo.ParentGroup = groupWeek50;
            band.Columns["Dec 10"].RowLayoutColumnInfo.ParentGroup = groupWeek50;
            band.Columns["Dec 11"].RowLayoutColumnInfo.ParentGroup = groupWeek50;
            band.Columns["Dec 12"].RowLayoutColumnInfo.ParentGroup = groupWeek50;
            band.Columns["Dec 13"].RowLayoutColumnInfo.ParentGroup = groupWeek50;
            band.Columns["Dec 14"].RowLayoutColumnInfo.ParentGroup = groupWeek51;
            band.Columns["Dec 15"].RowLayoutColumnInfo.ParentGroup = groupWeek51;
            band.Columns["Dec 16"].RowLayoutColumnInfo.ParentGroup = groupWeek51;
            band.Columns["Dec 17"].RowLayoutColumnInfo.ParentGroup = groupWeek51;
            band.Columns["Dec 18"].RowLayoutColumnInfo.ParentGroup = groupWeek51;
            band.Columns["Dec 19"].RowLayoutColumnInfo.ParentGroup = groupWeek51;
            band.Columns["Dec 20"].RowLayoutColumnInfo.ParentGroup = groupWeek51;
            band.Columns["Dec 21"].RowLayoutColumnInfo.ParentGroup = groupWeek52;
            band.Columns["Dec 22"].RowLayoutColumnInfo.ParentGroup = groupWeek52;
            band.Columns["Dec 23"].RowLayoutColumnInfo.ParentGroup = groupWeek52;
            band.Columns["Dec 24"].RowLayoutColumnInfo.ParentGroup = groupWeek52;
            band.Columns["Dec 25"].RowLayoutColumnInfo.ParentGroup = groupWeek52;
            band.Columns["Dec 26"].RowLayoutColumnInfo.ParentGroup = groupWeek52;
            band.Columns["Dec 27"].RowLayoutColumnInfo.ParentGroup = groupWeek52;
            band.Columns["Dec 28"].RowLayoutColumnInfo.ParentGroup = groupWeek53;
            band.Columns["Dec 29"].RowLayoutColumnInfo.ParentGroup = groupWeek53;
            band.Columns["Dec 30"].RowLayoutColumnInfo.ParentGroup = groupWeek53;
            band.Columns["Dec 31"].RowLayoutColumnInfo.ParentGroup = groupWeek53;

            foreach (UltraGridColumn col in band.Columns)
            {
                if(col.Key.StartsWith("Dec"))
                {
                    col.Width = 5;
                }
            }
        }
    }
}
